"""
Leser ngrammer, ord/tagg-relasjoner og suffiks/tagg-relasjoner fra filer.
"""

class Data:
    """
    Klasse for treningsdata, slik de leses fra fil.
    """
    def __init__(self, path = "", n=3):
        self.total = 0 # totalt antall tagger
        self.n = n # n-gramstrrelse
        self.ngrams = {0 : {() : 0}}
        self.words = {}
        self.suffixes = {}
        self.path = path
 
    def read_ngrams(self):
        """
        Leser n-gramsannsynligheter fra fil.
        """
        print "Leser n-grammer..."
        import re
        n = re.compile(r'^(.+?)\t.+?$') # finn ngram
        c = re.compile(r'^.+?\t(.+?)$') # # finn count
        for i in range(self.n): # for hver ngramsrrelse
            ngramfile = open(self.path + str(i+1)+ ".txt", 'r') # pne ngram-fil
            self.ngrams[i+1] = {} # initialiser ngramtabell
            for line in ngramfile: # for hver ngram
                ngram = n.search(line)
                count = c.search(line)
                self.ngrams[i+1][eval(ngram.group(1))] = eval(count.group(1)) # lagre i tabell
                if i == 0: #hvis unigram
                    self.ngrams[i][()] = self.ngrams[i][()] + eval(count.group(1)) # oppdater totalt antall tagger (dvs tokens)
            self.ngrams[i+1][tuple([None]*(i+1))] = self.ngrams[0][()]

    def read_words(self):
        """
        Leser ord/tagg-relasjoner fra fil.
        """
        print "Leser ord..."
        import re
        w = re.compile(r'^(.+?)\t.+?\t.+?$') # finn ord
        t = re.compile(r'.+?\t(.+?)\t.+?$') # finn tagg
        c = re.compile(r'^.+?\t.+?\t(.+?)$') # # finn count
        wordfile = open(self.path + "words.txt", 'r') # pne ord-fila
        for line in wordfile: # for hvert ord/tagg-par
            word = w.search(line)
            tag = t.search(line)    
            count = c.search(line)
            if word.group(1) in self.words: # hvis ordet ligger i tabellen
                self.words[word.group(1)][tag.group(1)] = eval(count.group(1)) # lagre i tabell            
            else: # hvis ordet ikke ligger i tabellen
                self.words[word.group(1)] = {tag.group(1) : eval(count.group(1))} # lagre i tabell

    def read_suffixes(self):
        """
        Leser suffiks/tagg-realsjoner fra fil.
        """
        print "Leser suffikser..."
        import re
        s = re.compile(r'^(.+?)\t.+?\t.+?$') # finn suffiks
        t = re.compile(r'.+?\t(.+?)\t.+?$') # finn tagg
        c = re.compile(r'^.+?\t.+?\t(.+?)$') # # finn count
        suffixfile = open(self.path + "suffixes.txt", 'r') # pne suffiks-fila
        for line in suffixfile: # for hvert suffiks/tagg-par
            suffix = s.search(line)
            tag = t.search(line)    
            count = c.search(line)
            if suffix.group(1) in self.suffixes: # hvis suffikset ligger i tabellen
                self.suffixes[suffix.group(1)][tag.group(1)] = eval(count.group(1)) # lagre i tabell            
            else: # hvis suffikset ikke ligger i tabellen
                self.suffixes[suffix.group(1)] = {tag.group(1) : eval(count.group(1))} # lagre i tabell

    def read_from_files(self):
        """
        Leser opptelte treningsdata fra fil.
        """
        print "Starter opptrening."
        self.read_ngrams()
        self.read_words()
        self.read_suffixes()
        print "Opptrening ferdig."


