#!/usr/bin/python
import os
import read_data
D = read_data.Data(os.path.dirname(os.path.abspath(__file__))+'/')
D.read_from_files()
import get_probs
M = get_probs.Model(D)
import edit_data
E = edit_data.Edit()
import sys, getopt

def tag(source, Model=M):
    """
    Tagger en setning.
    """
    source = source.split(None)
    import viterbi
    B = viterbi.ParB(source,Model)
    B.create_tab()
    A = viterbi.ParA(source,Model)
    A.create_list(B)
    A.create_tab()
    S = viterbi.States(source)
    S.fill_tab(B)
    V = viterbi.Decoder(source, A, B, S)
    V.fill_first()
    V.fill_rest()
    return V.find_best_tags()

def tag_file(File, OutputFile, Model=M):
    """
    Tagger alle setningene i en fil.
    """
    incorpus = open(File, 'r') # pner fila for lesing
    outcorpus = open(OutputFile + ".tag", 'w')  
    for line in incorpus:
        tags = tag(line, Model)
        M.clear_lists()
        streng = ''
        words = line.split(None)
        for i in range(len(words)):
            streng = streng + words[i] + '<' + tags[i] + ':w> '
        outcorpus.write(streng[0:-1] + "\n")
    incorpus.close()
    outcorpus.close()
    
def tag_folder(inputfolder, outputFolder, Model=M):
    """
    Tagger alle setningene i en mappe.
    """
    files_in_dir = os.listdir(inputfolder)
    for file_in_dir in files_in_dir:
    	incorpus = open(inputfolder+"/"+file_in_dir, 'r') # pner fila for lesing
    	outcorpus = open(outputFolder+"/"+file_in_dir + ".tag", 'w')  
    	for line in incorpus:
       	    tags = tag(line, Model)
       	    M.clear_lists()
     	    streng = ''
            words = line.split(None)
            for i in range(len(words)):
            	streng = streng + words[i] + '<' + tags[i] + ':w> '
            outcorpus.write(streng[0:-1] + "\n")
    	incorpus.close()
    	outcorpus.close()
    
        
def tag_sentence(source, Model=M):
    """
    Tagger en setning.
    """
    tags = tag(source, Model)
    source = source.split(None)
    for i in range(len(source)):
 #       print source
 #       print tags
        print source[i] + "\t\t" + tags[i]
    for word in M.Numbers:
        print word + " is a number"
    for word in M.ProperNouns:
        print word + " is a proper noun"
    for word in M.Compounds:
        print word + " is a compound"
    for word in M.UnknownSuffix:
        print word + " has an unknown suffix"
    for word in M.KnownSuffix:
        print word + " has a known suffix"
    M.clear_lists()

def main(argv):
   inputfile = ''
   outputfile = ''
   try:
      opts, args = getopt.getopt(argv,"hi:o:",["ifile=","ofile="])
   except getopt.GetoptError:
      print 'tagger.py -i <inputfile> -o <outputfile>'
      sys.exit(2)
   for opt, arg in opts:
      if opt == '-h':
         print 'tagger.py -i <inputfile> -o <outputfile>'
         sys.exit()
      elif opt in ("-i", "--ifile"):
         inputfile = arg
      elif opt in ("-o", "--ofile"):
         outputfile = arg
   tag_folder(inputfile,outputfile)

if __name__ == "__main__":
   main(sys.argv[1:]) 

