#!/usr/bin/python
# -*- coding:utf-8 -*
import simstring
import sys
import argparse

def searchDatabase(databasefile, outputFile, threshold, searchString):
	newstring = searchString.decode('utf-8')
	newstring2= newstring.encode('utf-8')
	# Open the database for reading.
	db = simstring.reader(databasefile)

	# Use cosine similarity and threshold 0.6.
	db.measure = simstring.cosine
	db.threshold = threshold
	result = db.retrieve(newstring2)
	outFile = open(outputFile, 'w') 
	if not result:
		outFile.write('null')
	else:
		for line in result:
			outFile.write(line+'\n')

def main(argv):	
	parser = argparse.ArgumentParser()
	parser.add_argument('inputfile', nargs=1,help='a databasefile')
	parser.add_argument('outputfile', nargs=1,help='location of output resultfile')
	parser.add_argument('threshold', type=float,nargs=1,help='a databasefile')
	parser.add_argument('searchstring', nargs='+',help='searchstring')
	args = parser.parse_args()
	input = args.inputfile[0]
	output = args.outputfile[0]
	threshold = args.threshold[0]
	searchstring = ""
	for word in args.searchstring:
		searchstring += word+" "
	searchDatabase(input, output, threshold, searchstring)

if __name__ == "__main__":
	main(sys.argv[1:]) 
