#include "simstring.h"
#include <string>
#include <locale>
#include <iostream>


void buildDatabase(const std::string& inputTextFile,const std::string& outputDatabaseFile)
{
	simstring::ngram_generator gen(3, false);
    simstring::writer_base<std::wstring> databaseWriter(gen, outputDatabaseFile);

	std::wifstream input(inputTextFile);

	std::locale::global(std::locale(""));  //fjernes?
    std::wcout.imbue(std::locale(""));


	for( std::wstring line; getline( input, line ); )
	{
		databaseWriter.insert(line);
	}
	databaseWriter.close();
}

int main(int argc, char *argv[])
{
	std::locale::global(std::locale("")); 
    std::wcout.imbue(std::locale(""));

	  if (argc < 3) { // We expect 3 arguments: the program name, the source path and the destination path
                std::cerr << "Too few arguments" << std::endl;
					std::string buffer;
					std::cin >> buffer;
                return 1;
        }
      buildDatabase(argv[1], argv[2]); 
    return 0;
}