#include <iostream>
#include <locale>
#include <string>
#include <fstream>
#include "simstring.h"


void searchDatabase(const std::string& databasefile,const std::string& outputFile, double threshold, const std::wstring& searchString)
{
	simstring::reader databaseReader;
	databaseReader.open(databasefile);
	std::vector<std::wstring> resultVector;
	databaseReader.retrieve(searchString, simstring::cosine, threshold, std::back_inserter(resultVector));

	   std::wofstream out( outputFile );
   if( !out )
   {
      std::cout << "Couldn't open file."  << std::endl;
   }

   if((int)resultVector.size() == 0) 
   {
	    out << L"null";
   }
   else 
   {
	   	for (int i = 0;i < (int)resultVector.size();++i) {
		 out << resultVector[i] + L"\n";
		}
   }
   	out.close();
	databaseReader.close();

}
std::wstring convertwCharChar(char* arg) 
{
    size_t origsize = strlen(arg) + 1;
    const size_t newsize = 100;
    size_t convertedChars = 0;
    wchar_t wcstring[newsize];
    mbstowcs_s(&convertedChars, wcstring, origsize, arg, _TRUNCATE);
    return wcstring;
}


int main(int argc, char *argv[])
{
	std::locale::global(std::locale("")); 
    std::wcout.imbue(std::locale(""));

	  if (argc < 5) { // We expect 3 arguments: the program name, the source path and the destination path
                std::cerr << "Too few arguments" << std::endl;
					std::string buffer;
					std::cin >> buffer;
                return 1;
        }
	   std::istringstream istr(argv[3]);
	   double threshold;
	   istr >> threshold;


	   std::wstring resultstring = convertwCharChar(argv[4]);
	   if(argc > 5) { 
	   	   for(int i = 5; i < argc; i++) {
		   std::wstring temp = convertwCharChar(argv[i]);
		   resultstring = resultstring+L" " + temp;
		   }
	   }

	   std::wcout << resultstring  << std::endl;
	   
      searchDatabase(argv[1], argv[2], threshold, resultstring); 
    return 0;
}
