package no.ntnu.idi.deid.decision.validators.findPhrase.helpers;

import java.util.ArrayList;
import java.util.List;

import no.ntnu.idi.deid.documentunits.Phrase;
import no.ntnu.idi.deid.documentunits.Sentence;

public class LevenshteinWordDistance {

	public static Phrase findPhrase(Sentence sentence, String phrase,
			int distance) {
		String[] phraseArray = phrase.split(" ");
		int numberOfMatches = 0;
		Phrase returnPhrase = null;
		List<Integer> indexList = new ArrayList<Integer>();
		if (phraseArray != null) {
			for (int j = 0; j < phraseArray.length; j++) {
				for (int i = 0; i < sentence.size(); i++) {
					if (phraseArray[j].toLowerCase().equals(
							sentence.get(i).getStripped().toLowerCase())) {
						numberOfMatches++;
						indexList.add(i);
					}
				}
			}
		}
		if (phraseArray.length == numberOfMatches) {
			returnPhrase = new Phrase();
			for (Integer index : indexList) {
				returnPhrase.add(sentence.get(index));
			}
		} else if (phraseArray.length < numberOfMatches) {
			System.err
					.println("LevhensthetinOrdNivå: phrasen matcha et ord i setningen flere ganger, kan ha skapt mulig bug. Setningen er: "
							+ sentence.getStripped()
							+ "og dokumentet er: "
							+ sentence.getDocument().getName());
			returnPhrase = new Phrase();
			for (Integer index : indexList) {
				returnPhrase.add(sentence.get(index));
			}
		}
		return returnPhrase;
	}

}
