package no.ntnu.idi.deid.patternmatching.search.dictionary.medicalcodes;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;

import no.ntnu.idi.deid.config.FilePaths;
import no.ntnu.idi.deid.documentunits.Token;
import no.ntnu.idi.deid.searchresultunits.CategoryTag;
import no.ntnu.idi.deid.searchresultunits.Tag;

public class NCSP_Codes {
	
	private static Map<String, String> NCSPCodes;

//	private static int testCounter = 0;
	
	private NCSP_Codes(){
		if(NCSPCodes==null){try {
			readAndMakeNCSPCodes();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}}
	}
	
	public static CategoryTag searchNCSPCode(Token t) {
		new NCSP_Codes();
		if(NCSPCodes.containsKey(t.getStripped())){
			CategoryTag tag = new CategoryTag(Tag.NCSP);
			tag.setValues(t.getStripped(), NCSPCodes.get(t.getStripped()));
			return tag;
		}
		return null;
	}
	
	public static CategoryTag searchExactDescription(String str) {
		new NCSP_Codes();
		Iterator<Entry<String, String>> it = NCSPCodes.entrySet().iterator();
		while(it.hasNext()){
			Map.Entry<String, String> entry = (Map.Entry<String, String>) it.next();
			if(entry.getValue().equals(str.trim())){
				CategoryTag tag = new CategoryTag(Tag.NCSP);
				tag.setValues(entry.getKey(), entry.getValue());
				return tag;
			}
		}
		return null;
	}
	
	private void readAndMakeNCSPCodes() throws FileNotFoundException{
		NCSPCodes = new HashMap<String,String>();
		Scanner sc = new Scanner(new File(FilePaths.getNCSPCodesPath()));
		while(sc.hasNext()){
			String[] split= sc.nextLine().split("\\$");
			if(split.length==2){handleLine(split);}
		}
		sc.close();
	}
	
	private void handleLine(String[] split){
//		testCounter++;
		if(split[0].length()!=5){}
		NCSPCodes.put(split[0].trim(), split[1].trim());
	}
}
