package no.ntnu.idi.documentunits.test;

import static org.junit.Assert.*;

import java.lang.reflect.Field;

import no.ntnu.idi.deid.documentunits.Document;
import no.ntnu.idi.deid.documentunits.TokenIterator;
import no.ntnu.idi.deid.preprocessor.Documents;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class TokenIteratorTest {

	Document mDocument;
	

	@Before
	public void setUp() throws Exception {
		mDocument = new Documents().getDocuments().get(0);
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testHasNext() {
		TokenIterator tokenIterator = new TokenIterator(mDocument);
		assertTrue(tokenIterator.hasNext());		
	}
	
	@Test
	public void testHasNextBase() throws IllegalArgumentException, IllegalAccessException, NoSuchFieldException, SecurityException {
		TokenIterator tokenIterator = new TokenIterator(mDocument);
		Class<? extends TokenIterator> tokenIteratorClass = tokenIterator.getClass();
		Field tokenPointerField = tokenIteratorClass.getDeclaredField("mTokenPointer");
		tokenPointerField.setAccessible(true);
		assertEquals(0, tokenPointerField.get(tokenIterator));
	}
	

}
