package no.ntnu.idi.patternmatching.search.dictionary.medicalcodes.test;

import no.ntnu.idi.deid.documentunits.Token;
import no.ntnu.idi.deid.patternmatching.search.dictionary.medicalcodes.ATC_Codes;
import no.ntnu.idi.deid.searchresultunits.CategoryTag;
import no.ntnu.idi.deid.searchresultunits.Tag;

import org.junit.*;
import static org.junit.Assert.*;

public class ATC_CodesTest{
	
	private String validCode;
	private String validCode2;
	private String validCode3;
	private String invalidCode;
	
	private CategoryTag validTag;
	private CategoryTag validTag2;
	private CategoryTag validTag3;
	private CategoryTag invalidTag;
	
    @Before
    public void setUp() {
    	validCode = "A11HA04";
    	validCode2 = "J01DB03";
    	validCode3 = "R06AE07";
    	invalidCode = "A11HA0";
    	
		validTag = ATC_Codes.searchATC(new Token(1, validCode));
		validTag2= ATC_Codes.searchATC(new Token(1, validCode2));
		validTag3 = ATC_Codes.searchATC(new Token(1, validCode3));
		invalidTag = ATC_Codes.searchATC(new Token(2, invalidCode));
    }
		
	@Test
	public void testValidTag() {
		assertEquals(Tag.ATC, validTag.getTag());
		assertEquals(Tag.ATC, validTag2.getTag());
		assertEquals(Tag.ATC, validTag3.getTag());
	}
	
	@Test
	public void testValidCode() {
		assertEquals(validCode, validTag.getCode());
		assertEquals(validCode2, validTag2.getCode());
		assertEquals(validCode3, validTag3.getCode());
	}
	
	@Test
	public void testDescription() {	
		assertEquals("Riboflavin (Vit B2)", validTag.getDescription());
		assertEquals("Cefalotin", validTag2.getDescription());
		assertEquals("Cetirizin", validTag3.getDescription());
	}
	
	@Test
	public void testInValidATCCode() {
		assertNull(invalidTag);
	}
}
