package no.ntnu.idi.patternmatching.search.dictionary.medicalcodes.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import no.ntnu.idi.deid.documentunits.Token;
import no.ntnu.idi.deid.patternmatching.search.dictionary.medicalcodes.ICD10_Codes;
import no.ntnu.idi.deid.searchresultunits.CategoryTag;
import no.ntnu.idi.deid.searchresultunits.Tag;

import org.junit.Before;
import org.junit.Test;

public class ICD10_CodesTest {
	

	private String validCode;
	private String validCode2;
	private String validCode3;
	private String invalidCode;
	
	private CategoryTag validTag;
	private CategoryTag validTag2;
	private CategoryTag validTag3;
	private CategoryTag inValidTag;
	
	
	
    @Before
    public void setUp() {
    	validCode = "Y840";
    	validCode2 = "Y848";
    	validCode3 = "Y911";
    
    	invalidCode = "Y848222";

        validTag = ICD10_Codes.searchICD10Code(new Token(1, validCode));
        validTag2 = ICD10_Codes.searchICD10Code(new Token(3, validCode2));
        validTag3 = ICD10_Codes.searchICD10Code(new Token(4, validCode3));
        		
        inValidTag = ICD10_Codes.searchICD10Code(new Token(2, invalidCode));
    }
	
		
	@Test
	public void testValidTag() {
		assertEquals(Tag.ICD10, validTag.getTag());
		
	}
	
	@Test
	public void testValidCode() {
		assertEquals(validCode, validTag.getCode());
		assertEquals(validCode2, validTag2.getCode());
		assertEquals(validCode3, validTag3.getCode());
		
	}
	
	
	@Test
	public void testValidDescription() {
		assertEquals("Hjertekateterisering", validTag.getDescription());
		assertEquals("Annen medisinsk prosedyre", validTag2.getDescription());
	}
	
	@Test
	public void testInValidICD10Code() {
		assertNull(inValidTag);
	}
	

}
