package no.ntnu.idi.patternmatching.search.dictionary.medicalcodes.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import no.ntnu.idi.deid.documentunits.Token;
import no.ntnu.idi.deid.patternmatching.search.dictionary.medicalcodes.Medical_Keyword;
import no.ntnu.idi.deid.searchresultunits.CategoryTag;
import no.ntnu.idi.deid.searchresultunits.Tag;

import org.junit.Before;
import org.junit.Test;

public class Medical_KeywordTest {

	
	
	
	private String validTerm;
	private String validTerm2;
	private String validTerm3;
	private String invalidTerm;
	private Tag tag;
	
	
	private CategoryTag validTag;
	private CategoryTag validTag2;
	private CategoryTag validTag3;
	private CategoryTag invalidTag;
		
    @Before
    public void setUp() {
    	tag = Tag.MEDICALKEYWORD;
    	validTerm = "abdomen";
    	validTerm2 = "årsak";
    	validTerm3 = "reovirus";
    	invalidTerm = "InvalidTerm";

		validTag = Medical_Keyword.searchInMedicalKeywords(new Token(1, validTerm));
		validTag2= Medical_Keyword.searchInMedicalKeywords(new Token(1, validTerm2));
		validTag3 = Medical_Keyword.searchInMedicalKeywords(new Token(1, validTerm3));
		invalidTag = Medical_Keyword.searchInMedicalKeywords(new Token(2, invalidTerm));
		
    }
		
	@Test
	public void testValidTag() {
		assertEquals(tag, validTag.getTag());
		assertEquals(tag, validTag2.getTag());
		assertEquals(tag, validTag3.getTag());
	}	
	
	@Test
	public void testInValidCode() {
		assertNull(invalidTag);
	}

}
