package no.ntnu.idi.patternmatching.search.dictionary.medicalcodes.test;

import static org.junit.Assert.*;

import no.ntnu.idi.deid.documentunits.Token;
import no.ntnu.idi.deid.patternmatching.search.dictionary.medicalcodes.Zip_Code;
import no.ntnu.idi.deid.searchresultunits.CategoryTag;
import no.ntnu.idi.deid.searchresultunits.Tag;

import org.junit.Before;
import org.junit.Test;

public class Zip_CodeTest {


	private String validCode;
	private String validCode2;
	private String validCode3;
	private String invalidCode;
	private Tag tag;
	
	private String validDescription;
	private String validDescription2;
	private String validDescription3;
	
	private CategoryTag validTag;
	private CategoryTag validTag2;
	private CategoryTag validTag3;
	private CategoryTag invalidTag;
		
    @Before
    public void setUp() {
    	tag = Tag.ZIPCODE;
    	validCode = "0001";
    	validCode2 = "9991";
    	validCode3 = "6429";
    	invalidCode = "0002";
    	
    	validDescription = "OSLO";
    	validDescription2 = "BÅTSFJORD";
    	validDescription3 = "MOLDE";
    	
		validTag = Zip_Code.searchInZipcodes(new Token(1, validCode));
		validTag2= Zip_Code.searchInZipcodes(new Token(2, validCode2));
		validTag3 = Zip_Code.searchInZipcodes(new Token(3, validCode3));
		invalidTag = Zip_Code.searchInZipcodes(new Token(4, invalidCode));
    }
		
	@Test
	public void testValidTag() {
		assertEquals(tag, validTag.getTag());
		assertEquals(tag, validTag2.getTag());
		assertEquals(tag, validTag3.getTag());
	}
	
	@Test
	public void testValidCode() {
		assertEquals(validCode, validTag.getCode());
		assertEquals(validCode2, validTag2.getCode());
		assertEquals(validCode3, validTag3.getCode());
	}
	
	@Test
	public void testDescription() {	
		assertEquals(validDescription, validTag.getDescription());
		assertEquals(validDescription2, validTag2.getDescription());
		assertEquals(validDescription3, validTag3.getDescription());
	}
		
	@Test
	public void testInValidCode() {
		assertNull(invalidTag);
	}



}
